#!/bin/bash

function drop_cache {
	sync && echo 3 > /proc/sys/vm/drop_caches
}

umount /mnt/fs-test &>/dev/null
rm /mnt/fs-test -rf
mkdir -p /mnt/fs-test

for FS in ext2 ext3 ext4dev jfs ntfs-3g reiser4 reiserfs vfat xfs ; do
	echo;echo;echo
	echo '***************************************************'
	echo "*            Do test $FS"
	echo '***************************************************'

	START=`php -r "echo time();"`

	FLAGS=''
	if [[ $FS == ext2 ]]; then mkfs.ext2 /dev/sda6; fi
	if [[ $FS == ext3 ]]; then mkfs.ext3 -j /dev/sda6; fi
	if [[ $FS == ext4dev ]]; then mkfs.ext3 -j /dev/sda6; fi
	if [[ $FS == jfs ]]; then echo Y | mkfs.jfs -f /dev/sda6; fi
	if [[ $FS == minix ]]; then mkfs.minix /dev/sda6; fi
	if [[ $FS == ntfs-3g ]]; then mkfs.ntfs -f -F /dev/sda6; fi
	if [[ $FS == reiserfs ]]; then mkfs.reiserfs -f /dev/sda6; fi
	if [[ $FS == reiser4 ]]; then mkfs.reiser4 -y /dev/sda6; fi
	if [[ $FS == vfat ]]; then mkfs.vfat /dev/sda6; fi
	if [[ $FS == xfs ]]; then mkfs.xfs -f /dev/sda6; fi

	mount -t $FS /dev/sda6 /mnt/fs-test || die "Can't mount $FS"
	rm /mnt/fs-test/* -rf
	mount| grep /dev/sda6

	drop_cache
	time ./fill.sh
#	echo 1111 > /mnt/fs-test/1.so
	
	echo; echo -n ">>>>>>> Сброс кеша"
	time drop_cache
	if [[ $FS != 'ext4dev' ]]; then	
		echo; echo -n ">>>>>>> Остаточная фрагментация "
		time /root/fragck.pl /mnt/fs-test/
	fi

	echo; echo ">>>>>>> Свободное место"
	df -k /mnt/fs-test
	du -ks /mnt/fs-test
	
	echo; echo -n ">>>>>>> Сброс кеша"
	time drop_cache
	time ./read.sh

	echo; echo -n ">>>>>>> Сброс кеша"
	time drop_cache

	umount /mnt/fs-test

	echo -n Полное вреvя теста: 
	php -r "echo (time()-${START}).\"\n\";"
done
